#ifndef CANVASVIEW_H
#define CANVASVIEW_H

#include <qwidget.h>
#include <qcanvas.h>
#include <list>
#include "Canvas.h"
#include "../base_gui/gEngine.h"
#include "../base_gui/gBelt.h"
#include "../base_gui/gAlpha.h"
#include "../base_gui/gOmega.h"
#include "../base_gui/gMiddle.h"
#include "../base/devices/Device.h"

class CanvasView : public QCanvasView
{
	Q_OBJECT
	public:
		CanvasView( QWidget * parent, const char *name = 0 );
		~CanvasView();
		Canvas* getCanvas();
		void setGeometry(int, int, int, int);
		void setGeometry(QRect);
		
	private:
		Canvas *oCanvas;
		double particleVelocity;
		int delay;
			
	    protected:
		int cycleCount;
		std::list<Device*> deviceList;
		std::list<gBelt*> beltList;
		
		void position();
		void changeMiddleSpeed(int speed);

	    signals:
		void sig_stats(int total, int good, int withoutCarcass, int withoutValves, int withoutStarter, int withoutLid);
		
	    public slots:
		void create();
		void start(int delay);
		void stop();
		void advanced();
		void changeDelay(int delay);		
		void changeSpeed(int speed);
};

#endif //CANVASVIEW_H
