#include "Canvas.h"
#include <iostream>
using namespace std;

Canvas::Canvas( QWidget *parent, const char *name ): QCanvasView( parent, name )
{
	oCanvas = new QCanvas(this, "Canvas");

	oCanvas->setDoubleBuffering(true);
	this->setCanvas(oCanvas);
	
	oCanvas -> setBackgroundColor (Qt::darkGray);
	oCanvas->resize(this->width()-2, this->height()-2);
	
}

Canvas::~Canvas()
{
    hide();
    delete oCanvas;
    oCanvas = 0;
    /*delete eng;
    eng = 0;
    delete belt1;
    belt1 = 0;
    delete alp;
    alp = 0;*/
}

void Canvas::setGeometry(int x1, int x2, int x3, int x4)
{
    QWidget::setGeometry(x1, x2, x3, x4);
    oCanvas->resize(this->width()-2,this->height()-2);
}

void Canvas::setGeometry(QRect rect)
{
    QWidget::setGeometry(rect);
    oCanvas->resize(this->width()-2,this->height()-2);
}

void Canvas::testslot()
{
    eng = new gEngine(oCanvas);
    eng -> carcass = false;
    eng -> valves = true;
    eng -> starter = false;
    eng -> incSteps();
    eng -> incSteps();
    eng -> incSteps();
    eng -> setX(60);
    eng -> setY(gAlpha::V_GAP);
    eng -> show();
    
    belt1 = new gBelt(oCanvas, 4);
    belt1->setY(24+gAlpha::V_GAP);
    belt1->setX(60);
    belt1->show();
    
    alp = new gAlpha(oCanvas, belt1);
    //alp->setY(gAlpha::V_GAP);
    alp -> show();
    
    ome = new gOmega(oCanvas, belt1);
    ome->setX(60+belt1->WIDTH);
    ome -> show();
   
    mid = new gMiddle(oCanvas, belt1, belt1, 3);
    mid -> setX (belt1->WIDTH);
    mid -> setY (gEngine::HEIGHT+gAlpha::V_GAP+gMiddle::HEIGHT);
    mid -> show();
    
    gEngine *newEng = new gEngine(oCanvas);
    newEng -> setX ( belt1->WIDTH+gMiddle::H_GAP );
    newEng -> setY ( gEngine::HEIGHT+gAlpha::V_GAP+gMiddle::V_GAP*2 + 55);
    newEng -> show();
    
    oCanvas->update();
}

void Canvas::testslot2()
{
    eng->setVelocity(1,0);
    oCanvas -> setAdvancePeriod(50);
    eng->setAnimated(true);
    belt1->setVelocity(1, 0);
    belt1->setAnimated(true);
    alp -> setAnimated(true);
    oCanvas->advance();
}

void Canvas::advance()
{
    //QCanvas::advance();
}
