#ifndef GALPHA_H
#define GALPHA_H

#include "../base/devices/Alpha.h"
#include "gBelt.h"
#include "gEngine.h"
#include <qpainter.h>
#include <qcanvas.h>

class gAlpha: public QCanvasPolygonalItem, public Alpha
{
private:
    static const QColor C_DEVICE;
    static const QColor C_INSIDE;
    int cycleCount;
    gEngine *lastCreated;
    
public:
    static const int H_GAP;
    static const int V_GAP;
    static const int WIDTH;
    static const int HEIGHT;
    
public:
    gAlpha(QCanvas *canvas, gBelt *toBelt);
    ~gAlpha();
    
private:
    void newEngine();
    
protected:
    //overrides in Alpha
    virtual void doStep();
    
    //overrides in QCanvasPolygonalItem
    virtual void drawShape ( QPainter & p );
    virtual QPointArray areaPoints() const;
    virtual void advance(int phase);
    
signals:
    void sig_newEngine(gAlpha *origin);
};

#endif //GALPHA_H
