#ifndef GBELT_H
#define GBELT_H

#include <qcanvas.h>
#include "../base/Belt.h"
#include "gEngine.h"

class gBelt: public QCanvasPolygonalItem, public Belt {
protected:
    int angle;
public:
    static const QColor C_OUTLINE;
    static const QColor C_RECT;
    static const QColor C_WHEELS;
    
    static const int HEIGHT;
    static const int GAP_SIZE;
    
    const int WIDTH;
    const int direction;
    
public:
    gBelt( QCanvas *canvas, int capacity, int direction, Belt *previous = 0 );
    ~gBelt();
    
    gEngine *getEngineAtEnd();
    int deviceCount() const;
    const QPoint* getArrivalPoint() const;
    
    virtual void doStep();
    
protected:
    virtual void drawShape ( QPainter & p );
    virtual QPointArray areaPoints() const;
    virtual void advance(int phase);
    
    friend class CanvasView;
};

#endif //GBELT_H
