#ifndef GENGINE_H
#define GENGINE_H

#include <qcanvas.h>
#include "../base/Engine.h"

class gEngine: public QCanvasPolygonalItem, public Engine {
public:
    static const QColor C_ENGINE;
    static const QColor C_FULL;
    static const QColor C_EMPTY;
    static const QColor C_BAD;
    
    static const int PART_SIZE;
    static const int PART_HEIGHT;
    static const int GAP_SIZE;
    
    static const int WIDTH;
    static const int HEIGHT;
    
    int stepsTaken;
public:
    gEngine( QCanvas *canvas );
    ~gEngine();
    
    void incSteps() { stepsTaken++; }
    int getSteps() const { return stepsTaken; }
protected:
    virtual void drawShape ( QPainter & p );
    virtual QPointArray areaPoints() const;
};

#endif //GENGINE_H
