#ifndef GMIDDLE_H
#define GMIDDLE_H

#include "../base/devices/Middle.h"
#include "gBelt.h"
#include "gEngine.h"
#include <qpainter.h>
#include <qcanvas.h>

class gMiddle: public QCanvasPolygonalItem, public Middle
{
public:
    enum Stage { NONE, GET_ENGINE, MAKE_PART, RETRACT, PUT_ENGINE };
private:
    static const QColor C_DEVICE;
    static const QColor C_INSIDE;
    
    bool defect;
    bool screwed;
    QColor *part_color;
    
    
    Stage stage;
    int cycleCount;
    int trigger;
    
    gEngine *holding;
    
    QCanvasLine *line1;
    QCanvasLine *line2;
    
public:
    static const int H_GAP;
    static const int V_GAP;
    static const int WIDTH;
    static const int HEIGHT;
    
public:
    gMiddle(QCanvas *canvas, gBelt *fromBelt, gBelt *toBelt, int whatToDo);
    ~gMiddle();
    
private:
    void makePart();
    void setArrivalCoords();
    void setTargetCoords();
    void assertArrivalCoords();
    void assertTargetCoords();
    void screwPart();
    
protected:
    //overrides in Middle
    virtual void doStep();
    
    //overrides in QCanvasPolygonalItem
    virtual void drawShape ( QPainter & p );
    virtual QPointArray areaPoints() const;
    virtual void advance(int phase);
    
    friend class CanvasView;
};

#endif //GMIDDLE_H

