#ifndef GOMEGA_H
#define GOMEGA_H

#include "../base/devices/Omega.h"
#include "gEngine.h"
#include "gBelt.h"
#include <qpainter.h>
#include <qcanvas.h>
#include <qobject.h>
#include <list>

class gOmega: public QObject, public QCanvasPolygonalItem, public Omega
{
    Q_OBJECT
private:
    static const QColor C_DEVICE;
    static const QColor C_INSIDE;
    std::list<gEngine*> toBeDestroyed;
    
public:
    static const int H_GAP;
    static const int V_GAP;
    static const int WIDTH;
    static const int HEIGHT;
    
public:
    gOmega(QCanvas *canvas, gBelt *fromBelt);
    ~gOmega();
    
signals:
    void sig_stats(int total, int good, int withoutCarcass, int withoutValves, int withoutStarter, int withoutLid);
    
protected:
    void destroyOld();
    
    //overrides in Omega
    virtual void doStep();
    
    //overrides in QCanvasPolygonalItem
    virtual void drawShape ( QPainter & p );
    virtual QPointArray areaPoints() const;
    virtual void advance(int phase);
};

#endif //GALPHA_H
